#include <glib.h>
#include <gmodule.h>

#include <cdb/cdb.h>

CDBDatum *cdb_datum_new(gsize klen, gchar *key, gsize dlen, gchar *data,
                        gboolean copy)
{
	CDBDatum *datum = g_new(CDBDatum, 1);

	datum->klen = klen;
	datum->dlen = dlen;
	if (copy) {
		datum->key = g_memdup(key, klen + 1);
		datum->key[klen] = 0;
		datum->data = g_memdup(data, dlen + 1);
		datum->data[dlen] = 0;
	} else {
		datum->key = key;
		datum->data = data;
	}

	return datum;
}

void cdb_datum_free(CDBDatum *datum)
{
	g_return_if_fail(datum);

	g_free(datum->key);
	g_free(datum->data);
	g_free(datum);
}
