#include <glib.h>

#include <cdb/cdb.h>
#include "internal.h"

#define CDB_HASH_START		5381

GQuark cdb_error_quark(void)
{
	static GQuark error_quark = 0;

	if (G_UNLIKELY(error_quark == 0))
		error_quark =
			g_quark_from_static_string("cdb-error-quark");

	return error_quark;
}

guint32 cdb_hash(gsize klen, const gchar *key)
{
	const gchar *end = key + klen;
	guint32 hash = CDB_HASH_START;

	while(key < end)
		hash = ((hash << 5) + hash) ^ *(guchar *)key++;

	return hash;
}
