#ifndef __CDB_WRITER_H__
#define __CDB_WRITER_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define CDB_TYPE_WRITER			(cdb_writer_get_type())
#define CDB_WRITER(o)			(G_TYPE_CHECK_INSTANCE_CAST((o), CDB_TYPE_WRITER, CDBWriter))
#define CDB_IS_WRITER(o)		(G_TYPE_CHECK_INSTANCE_TYPE((o), CDB_TYPE_WRITER))
#define CDB_WRITER_GET_CLASS(inst)	(G_TYPE_INSTANCE_GET_CLASS((inst), CDB_TYPE_WRITER, CDBWriterClass))

typedef struct _CDBWriter	CDBWriter;
typedef struct _CDBWriterClass	CDBWriterClass;

GType cdb_writer_get_type(void) G_GNUC_CONST;

CDBWriter *cdb_writer_new(const gchar *filename, guint mode,
                          GError **error) G_GNUC_MALLOC;

gboolean cdb_writer_putrec(CDBWriter *writer, CDBDatum *datum,
                           GError **error);
gboolean cdb_writer_finish(CDBWriter *writer, const gchar *filename,
                           GError **error);

G_END_DECLS

#endif /* __CDB_WRITER_H__ */
