#ifndef __MISC_USER_H__
#define __MISC_USER_H__

#include <sys/types.h>

#include <glib.h>
#include <glib-object.h>

#include <misc/utils.h>

G_BEGIN_DECLS

#define V_TYPE_USER		(v_user_get_type())
#define V_USER(o)		(G_TYPE_CHECK_INSTANCE_CAST((o), V_TYPE_USER, VUser))
#define V_IS_USER(o)		(G_TYPE_CHECK_INSTANCE_TYPE((o), V_TYPE_USER))
#define V_USER_GET_CLASS(inst)	(G_TYPE_INSTANCE_GET_CLASS((inst), V_TYPE_USER, VUserClass))

typedef struct _VUser		VUser;
typedef struct _VUserClass	VUserClass;

struct _VUser {
	GObject			gobject;
	gchar			*user;
	gchar			*home;
	gchar			*shell;
	uid_t			uid;
	gid_t			gid;
};

GType v_user_get_type(void) G_GNUC_CONST;

VUser *v_user_new(const gchar *name) G_GNUC_MALLOC;

gboolean v_user_become(VUser *user);

G_END_DECLS

#endif /* __MISC_USER_H__ */
