#ifndef __V_CONFIG_H__
#define __V_CONFIG_H__

#include <sys/types.h>

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define V_TYPE_CONFIG			(v_config_get_type())
#define V_CONFIG(o)			(G_TYPE_CHECK_INSTANCE_CAST((o), V_TYPE_CONFIG, VConfig))
#define V_IS_CONFIG(o)			(G_TYPE_CHECK_INSTANCE_TYPE((o), V_TYPE_CONFIG))
#define V_CONFIG_GET_CLASS(inst)	(G_TYPE_INSTANCE_GET_CLASS((inst), V_TYPE_CONFIG, VConfigClass))

typedef struct _VConfig		VConfig;
typedef struct _VConfigClass	VConfigClass;

GType v_config_get_type(void) G_GNUC_CONST;

VConfig *v_config_new(const gchar *filename, GError **error) G_GNUC_MALLOC;
VConfig *v_config_get_default(void);
void v_config_invalidate_default(void);

gchar *v_config_get_string(VConfig *config, const gchar *group,
                           const gchar *key) G_GNUC_MALLOC;
gchar **v_config_get_strv(VConfig *config, const gchar *group,
                          const gchar *key) G_GNUC_MALLOC;
int v_config_get_int(VConfig *config, const gchar *group,
                     const gchar *key) G_GNUC_CONST;
gboolean v_config_get_uint(VConfig *config, const gchar *group,
                           const gchar *key, guint *retval);
gboolean v_config_get_ulong(VConfig *config, const gchar *group,
                            const gchar *key, gulong *retval);

G_END_DECLS

#endif /* __V_CONFIG_H__ */
