#ifndef __V_MAILDIR_H__
#define __V_MAILDIR_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define V_TYPE_MAILDIR			(v_maildir_get_type())
#define V_MAILDIR(o)			(G_TYPE_CHECK_INSTANCE_CAST((o), V_TYPE_MAILDIR, VMaildir))
#define V_IS_MAILDIR(o)			(G_TYPE_CHECK_INSTANCE_TYPE((o), V_TYPE_MAILDIR))
#define V_MAILDIR_GET_CLASS(inst)	(G_TYPE_INSTANCE_GET_CLASS((inst), V_TYPE_MAILDIR, VMaildirClass))

typedef struct _VMaildir	VMaildir;
typedef struct _VMaildirClass	VMaildirClass;

typedef enum {
	V_MAILDIR_CUR = 0,
	V_MAILDIR_NEW,
	V_MAILDIR_TMP,
} VMaildirCategory;

GType v_maildir_get_type(void) G_GNUC_CONST;

VMaildir *v_maildir_new(const gchar *name, GError **error) G_GNUC_MALLOC;
VMaildir *v_maildir_new_create(const gchar *name,
                               GError **error) G_GNUC_MALLOC;

gchar *v_maildir_get_base(VMaildir *maildir) G_GNUC_CONST;
gboolean v_maildir_delete(VMaildir *maildir, GError **error);
gpointer v_maildir_prepare(VMaildir *maildir, GIOChannel *in, gchar **headers,
                           GError **error);
gboolean v_maildir_deliver(VMaildir *maildir, gpointer handle, GError **error);
void v_maildir_abort(VMaildir *maildir, gpointer handle);

G_END_DECLS

#endif /* __V_MAILDIR_H__ */
