#ifndef __V_DOMAIN_AUTH_H__
#define __V_DOMAIN_AUTH_H__

#include <glib.h>
#include <glib-object.h>

#include <misc/user.h>

G_BEGIN_DECLS

#define V_TYPE_DOMAIN_AUTH		(v_domain_auth_get_type())
#define V_DOMAIN_AUTH(o)		(G_TYPE_CHECK_INSTANCE_CAST((o), V_TYPE_DOMAIN_AUTH, VDomainAuth))
#define V_IS_DOMAIN_AUTH(o)		(G_TYPE_CHECK_INSTANCE_TYPE((o), V_TYPE_DOMAIN_AUTH))
#define V_DOMAIN_AUTH_CLASS(o)		(G_TYPE_CHECK_CLASS_CAST((o), V_TYPE_DOMAIN_AUTH, VDomainAuthClass))
#define V_IS_DOMAIN_AUTH_CLASS(o)	(G_TYPE_CHECK_CLASS_TYPE((o), V_TYPE_DOMAIN_AUTH))
#define V_DOMAIN_AUTH_GET_CLASS(inst)	(G_TYPE_INSTANCE_GET_INTERFACE((inst), V_TYPE_DOMAIN_AUTH, VDomainAuthClass))

#define V_AUTH_ERROR			v_auth_error_quark()

struct _VDomainAuthClass {
	GTypeInterface	g_iface;

	void		(*setup)(VDomainAuth *auth, VDomainEntry *entry);
	gboolean	(*auth)(VDomainAuth *auth, const gchar *pass,
			        GError **error);
	void		(*set)(VDomainAuth *auth, const gchar *pass);
};

typedef enum {
	V_AUTH_ERROR_NOTSUPP,
	V_AUTH_ERROR_NOENT,
	V_AUTH_ERROR_INVALID,
	V_AUTH_ERROR_DISABLED,
	V_AUTH_ERROR_EXPIRED,
	V_AUTH_ERROR_FAILED
} VAuthError;

GType v_domain_auth_get_type(void) G_GNUC_CONST;

extern GQuark v_auth_error_quark(void) G_GNUC_CONST;

G_END_DECLS

#endif /* __V_DOMAIN_AUTH_H__ */
