#include <string.h>

#include <glib.h>

#include <misc/utils.h>
#include <misc/vconfig.h>
#include <vdomain/vdomain.h>

#define DEFAULT_SEPARATORS	"@:"

void v_split_login_name(const gchar *login, gchar **user, gchar **domain)
{
	const gchar *p;
	gchar *separators = NULL;

	g_return_if_fail(login);
	g_return_if_fail(user && !*user);
	g_return_if_fail(domain && !*domain);

	separators = v_config_get_string(NULL, NULL, "separators");
	if (!separators)
		separators = DEFAULT_SEPARATORS;

	p = login + strcspn(login, separators);
	*user = g_strndup(login, p - login);
	if (*p)
		*domain = g_strdup(p + 1);

	if (separators != DEFAULT_SEPARATORS)
		g_free(separators);
}
