#include <stdio.h>

#include <glib.h>
#include <glib-object.h>

#include <misc/utils.h>
#include <qmail/qmail.h>
#include <vdomain/vdomain.h>

static int dump_entry(VDomain *domain, gchar *name)
{
	VDomainEntry *entry;
	gchar *tmp;
		
	tmp = g_strstrip(g_ascii_strdown(name, -1));
	entry = v_domain_get_entry(domain, tmp, NULL);
	g_free(tmp);
	if (!entry)
		return 1;

	tmp = v_domain_entry_output(entry);
	fputs(tmp, stdout);

	g_object_unref(entry);
	return 0;
}

int main(int argc, char **argv)
{
	VDomain *domain;
	gint retval = 1;

	v_init(&argc, &argv, NULL, NULL, _("USERNAME"),
	       _("Lists the user entry of a virtual domain"));


	if (argc < 2)
		v_init_error(_("Too few command-line arguments"));

	domain = v_domain_new(NULL, NULL, FALSE, NULL);
	if (!domain)
		goto out;

	retval = dump_entry(domain,argv[1]);
out:
	if (domain)
		g_object_unref(domain);

	return retval;
}
